/*
 * Macro Definitions
 */
#define TOOL_ERR_ENCODE_ERROR_CODE(base,no)        ( -1 * (((base) << 16) + no) )
#define TOOL_ERR_GET_BASE_FROM_ERROR_CODE(code)    ( (((code) * -1) >> 16) & 0x0000FFFF )
#define TOOL_ERR_GET_NO_FROM_ERROR_CODE(code)      ( ((code) * -1) & 0x0000FFFF )


/*
 * Error Base Definitions
 */
#define UNIX_ERR_BASE                  0
#define OOSQL_EXPORT_ERR_BASE          1

#define TOOL_NUM_OF_ERROR_BASES        2


/*
 * Error Definitions for OOSQL_EXPORT_ERR_BASE
 */
#define eBADPARAMETER_EXPORT           TOOL_ERR_ENCODE_ERROR_CODE(OOSQL_EXPORT_ERR_BASE,0)
#define eCANNOT_OPEN_FILE_EXPORT       TOOL_ERR_ENCODE_ERROR_CODE(OOSQL_EXPORT_ERR_BASE,1)
#define eCANNOT_CLOSE_FILE_EXPORT      TOOL_ERR_ENCODE_ERROR_CODE(OOSQL_EXPORT_ERR_BASE,2)
#define eFILE_WRITE_FAIL_EXPORT        TOOL_ERR_ENCODE_ERROR_CODE(OOSQL_EXPORT_ERR_BASE,3)
#define eFILE_EXEC_FAIL_EXPORT         TOOL_ERR_ENCODE_ERROR_CODE(OOSQL_EXPORT_ERR_BASE,4)
#define eINSUFFICIENT_DISK_SPACE_EXPORT TOOL_ERR_ENCODE_ERROR_CODE(OOSQL_EXPORT_ERR_BASE,5)
#define eUNDEFINED_DATABASE_NAME_EXPORT TOOL_ERR_ENCODE_ERROR_CODE(OOSQL_EXPORT_ERR_BASE,6)
#define eUNDEFINED_TABLES_EXPORT       TOOL_ERR_ENCODE_ERROR_CODE(OOSQL_EXPORT_ERR_BASE,7)
#define eUNHANDLED_CASE_EXPORT         TOOL_ERR_ENCODE_ERROR_CODE(OOSQL_EXPORT_ERR_BASE,8)
#define eUNHANDLED_TYPE_EXPORT         TOOL_ERR_ENCODE_ERROR_CODE(OOSQL_EXPORT_ERR_BASE,9)
#define eGIVEN_INDEXNAME_INVALID_EXPORT TOOL_ERR_ENCODE_ERROR_CODE(OOSQL_EXPORT_ERR_BASE,10)
#define eINVALID_INDEX_EXPORT          TOOL_ERR_ENCODE_ERROR_CODE(OOSQL_EXPORT_ERR_BASE,11)
#define eLRDS_ERROR_EXPORT             TOOL_ERR_ENCODE_ERROR_CODE(OOSQL_EXPORT_ERR_BASE,12)
#define eLOM_ERROR_EXPORT              TOOL_ERR_ENCODE_ERROR_CODE(OOSQL_EXPORT_ERR_BASE,13)
#define eCATALOG_ERROR_EXPORT          TOOL_ERR_ENCODE_ERROR_CODE(OOSQL_EXPORT_ERR_BASE,14)
#define eOOSQL_ERROR_EXPORT            TOOL_ERR_ENCODE_ERROR_CODE(OOSQL_EXPORT_ERR_BASE,15)
#define eTOO_BIG_DATAFILESIZE          TOOL_ERR_ENCODE_ERROR_CODE(OOSQL_EXPORT_ERR_BASE,16)
#define eTOO_BIG_INDEXFILESIZE         TOOL_ERR_ENCODE_ERROR_CODE(OOSQL_EXPORT_ERR_BASE,17)
#define NUM_ERRORS_OOSQL_EXPORT_ERR_BASE 18
